<template>
    <div class="container">
        
        <h1 class="h1 margin-top">USUARIOS </h1>
        <NuxtLink to="/user">&#60; Ver Usuarios.</NuxtLink>
        <div>
            <form @submit.prevent="submitForm">
                <table class="table" width="500px">
                    <tr>
                        <td width="150px">Nombre</td>
                        <td>
                            <input type="text" name="nombres" v-model="userInfo.nombres" autocomplete="off" />
                        </td>
                    </tr>
                    <tr>
                        <td>Apellido</td>
                        <td>
                            <input type="text" name="apellidos" v-model="userInfo.apellidos" autocomplete="off" />
                        </td>
                    </tr>
                    <tr>
                        <td>Edad	</td>
                        <td>
                            <input type="number" name="edad" v-model="userInfo.edad" autocomplete="off" />
                        </td>
                    </tr>
                    <tr>
                        <td>Tipo</td>
                        <td>
                            <select name="type" id="type" v-model="userInfo.type">
                                <option value="Paciente">Paciente</option>
                                <option value="Médico">Médico</option>
                                <option value="Enfermera">Enfermera</option>
                            </select>
                        </td>
                    </tr>
                    <tbody v-if="['Médico', 'Enfermera'].includes(userInfo.type)">
                        <tr>
                            <td>Correo</td>
                            <td>
                                <input type="email" name="correo" v-model="userInfo.correo" autocomplete="off" />
                            </td>
                        </tr>
                        <tr >
                            <td>Contraseña</td>
                            <td>
                                <input type="password" name="contra" v-model="userInfo.contra" autocomplete="off" />
                            </td>
                        </tr>
                    </tbody>
                    
                </table>
                <div>
                    <input type="submit" class="btn btn-primary" :value="currentAction.name" />
                </div>
            </form>
        </div>

    </div>
</template>
<script lang="ts" setup>
    import { baseActionDetection } from '~/server/utils/forms/actionsDetector';

    const routerInstance = (useRouter());
    const id = ref(routerInstance.currentRoute.value.params.id.toString());
    let currentAction = ref(baseActionDetection(parseInt(id.value), routerInstance.currentRoute.value));

    const userInfo = ref({
        id: 0,
        nombres: '',
        apellidos: '',
        edad: '',
        type: 'Paciente',
        correo: '',
        contra: '',
    });


    if (currentAction.value.index !== 0) {
        findItemById(parseInt(id.value));
    }

    async function findItemById(id: number) {
        userInfo.value = await $fetch(`/api/user?id=${id}`, {   
            method: 'GET',
            headers: { 'method': 'findRecord' }
        });
    }

    async function submitForm() {
        let r = await $fetch(`/api/user`, {   
            method: 'POST',
            body: userInfo.value,
            headers: { 'method': currentAction.value.method }
        });
        navigateTo('/user');
    }
</script>
